Subject: Re: linux-next: Tree for Sep 16 (kernel/sched/core.c)

From: Ingo Molnar <[email-masked]>
Date: Wed, 18 Sep 2019 08:05:53 +0200

* Randy Dunlap <[email-masked]> wrote:

> On 9/17/19 6:38 AM, Patrick Bellasi wrote:
> > 
> > On Tue, Sep 17, 2019 at 08:52:42 +0100, Ingo Molnar wrote...
> > 
> >> * Randy Dunlap <[email-masked]> wrote:
> >>
> >>> On 9/16/19 3:38 PM, Mark Brown wrote:
> >>>> Hi all,
> >>>>
> >>>> Changes since 20190915:
> >>>>
> >>>
> >>> on x86_64:
> >>>
> >>> when CONFIG_CGROUPS is not set:
> > 
> > Hi Randy,
> > thanks for the report.
> > 
> >>>   CC      kernel/sched/core.o
> >>> ../kernel/sched/core.c: In function ‘uclamp_update_active_tasks’:
> >>> ../kernel/sched/core.c:1081:23: error: storage size of ‘it’ isn’t known
> >>>   struct css_task_iter it;
> >>>                        ^~
> >>>   CC      kernel/printk/printk_safe.o
> >>> ../kernel/sched/core.c:1084:2: error: implicit declaration of function ‘css_task_iter_start’; did you mean ‘__sg_page_iter_start’? [-Werror=implicit-function-declaration]
> >>>   css_task_iter_start(css, 0, &it);
> >>>   ^~~~~~~~~~~~~~~~~~~
> >>>   __sg_page_iter_start
> >>> ../kernel/sched/core.c:1085:14: error: implicit declaration of function ‘css_task_iter_next’; did you mean ‘__sg_page_iter_next’? [-Werror=implicit-function-declaration]
> >>>   while ((p = css_task_iter_next(&it))) {
> >>>               ^~~~~~~~~~~~~~~~~~
> >>>               __sg_page_iter_next
> >>> ../kernel/sched/core.c:1091:2: error: implicit declaration of function ‘css_task_iter_end’; did you mean ‘get_task_cred’? [-Werror=implicit-function-declaration]
> >>>   css_task_iter_end(&it);
> >>>   ^~~~~~~~~~~~~~~~~
> >>>   get_task_cred
> >>> ../kernel/sched/core.c:1081:23: warning: unused variable ‘it’ [-Wunused-variable]
> >>>   struct css_task_iter it;
> >>>                        ^~
> >>>
> >>
> >> I cannot reproduce this build failue: I took Linus's latest which has all 
> >> the -next scheduler commits included (ad062195731b), and an x86-64 "make 
> >> defconfig" and a disabling of CONFIG_CGROUPS still resuls in a kernel 
> >> that builds fine.
> > 
> > Same here Ingo, I cannot reproduce on arm64 and !CONFIG_CGROUPS and
> > testing on tip/sched/core.
> > 
> > However, if you like, the following patch can make that code a
> > bit more "robust".
> > 
> > Best,
> > Patrick
> > 
> > ---8<---
> > From 7e17b7bb08dd8dfc57e01c2a7b6875439eb47cbe Mon Sep 17 00:00:00 2001
> > From: Patrick Bellasi <[email-masked]>
> > Date: Tue, 17 Sep 2019 14:12:10 +0100
> > Subject: [PATCH 1/1] sched/core: uclamp: Fix compile error on !CONFIG_CGROUPS
> > 
> > Randy reported a compiler error on x86_64 and !CONFIG_CGROUPS which is due
> > to uclamp_update_active_tasks() using the undefined css_task_iter().
> > 
> > Since uclamp_update_active_tasks() is used only when cgroup support is
> > enabled, fix that by properly guarding that function at compile time.
> > 
> > Signed-off-by: Patrick Bellasi <[email-masked]>
> > Link: https://lore.kernel.org/lkml/[email-masked]/
> > Fixes: commit babbe170e05 ("sched/uclamp: Update CPU's refcount on TG's clamp changes")
> 
> Acked-by: Randy Dunlap <[email-masked]> # build-tested
> 
> Thanks.

Build failures like this one shouldn't depend on the compiler version - 
and it's still a mystery how and why this build bug triggered - we cannot 
apply the fix without knowing the answer to those questions.

Can you reproduce the build bug with Linus's latest tree? If not, which 
part of -next triggers the build failure?

Thanks,

	Ingo